package concurrency.week04;

public class ConsumerProducerTest {

	private static int REPEATNUM = 100;

	public static void main(String[] args) throws InterruptedException {

		System.out
				.println("Test 1 with Resource 1 (no wait), one consumer and one producer");
		test_single(new Resource1(), REPEATNUM);

		System.out
				.println("\nTest 2.1 with Resource 2 (waitif-notify), one consumer and one producer");
		test_single(new Resource2(), REPEATNUM);

		System.out
				.println("\nTest 2.2 with Resource 2 (waitif-notify), two consumers and two producers");
		test_multi(new Resource2(), REPEATNUM);

		System.out
				.println("\nTest 3 with Resource 3 (waitif-notifyAll, two consumers and two producers");
		test_multi(new Resource3(), REPEATNUM);

		System.out
				.println("\nTest 4 with Resource 4 (Semaphore), two consumers and two producers");
		test_multi(new Resource4(), REPEATNUM);

	}

	static void test_single(Resource resource, int repeatNum)
			throws InterruptedException {
		Thread p1 = new Producer(resource, repeatNum);
		Thread c1 = new Consumer(resource, repeatNum);
		p1.start();
		c1.start();
		c1.join();
		p1.join();
		System.out.println(resource.getHistory());
	}

	static void test_multi(Resource resource, int repeatNum)
			throws InterruptedException {
		Thread p1 = new Producer(resource, repeatNum);
		Thread p2 = new Producer(resource, repeatNum);
		Thread p3 = new Producer(resource, repeatNum);
		Thread c1 = new Consumer(resource, repeatNum);
		Thread c2 = new Consumer(resource, repeatNum);
		Thread c3 = new Consumer(resource, repeatNum);
		p1.start();
		c1.start();
		p2.start();
		c2.start();
		p3.start();
		c3.start();
		c1.join();
		p1.join();
		c2.join();
		p2.join();
		c3.join();
		p3.join();
		System.out.println(resource.getHistory());
	}

}
